package de.mattv.fileserver.routes.admin;

import de.mattv.fileserver.data.Token;
import de.mattv.fileserver.util.AdminRestController;
import io.swagger.v3.oas.annotations.Parameter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.SpringApplication;
import org.springframework.context.ApplicationContext;
import org.springframework.web.bind.annotation.PostMapping;

@Slf4j
@AdminRestController
public class General {
    private final ApplicationContext ctx;

    public General(ApplicationContext ctx) {
        this.ctx = ctx;
    }

    @PostMapping("/un_sudo")
    private void unSudo(@Parameter(hidden = true) Token token) {
        token.unSudo();
    }

    @PostMapping("/shutdown")
    private void shutdown(@Parameter(hidden = true) Token token) {
        log.warn("Shutdown started by {}", token);
        SpringApplication.exit(ctx);
    }
}
