package de.mattv.fileserver.routes.auth;

import de.mattv.fileserver.Response;
import de.mattv.fileserver.data.Token;
import de.mattv.fileserver.data.User;
import de.mattv.fileserver.util.AuthUser;
import de.mattv.fileserver.util.UserRestController;
import io.swagger.v3.oas.annotations.Parameter;
import de.mattv.fileserver.util.NonNull;
import org.springframework.web.bind.annotation.PostMapping;

@UserRestController
public class SessionInfo {
    @PostMapping("/session")
    private @NonNull Response.Session session(@AuthUser User user, @Parameter(hidden = true) Token token) {
        return new Response.Session(
                user.name,
                user.tfaSecret != null,
                token.isAdmin(),
                token.inSudo()
        );
    }
}
