package de.mattv.fileserver.services;

import de.mattv.fileserver.util.NonNull;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.mail.MailSender;
import org.springframework.mail.SimpleMailMessage;
import org.springframework.stereotype.Service;

@Slf4j
@Service
public class Mailer {

    @Value("${mail.from}")
    private String from;

    private final MailSender mailSender;

    public Mailer(@SuppressWarnings("SpringJavaInjectionPointsAutowiringInspection") @NonNull MailSender mailSender) {
        this.mailSender = mailSender;
    }

    public void send(@NonNull String to, @NonNull String subject, @NonNull String body) {
        SimpleMailMessage msg = new SimpleMailMessage();
        msg.setTo(to);
        msg.setFrom(from);
        msg.setSubject("MFileserver - " + subject);
        msg.setText(body);
        mailSender.send(msg);
    }
}
